unit Main;

interface

uses
  Windows, PsAPI, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls;

type
  TMainForm = class(TForm)
    GrabImage: TImage;
    GrabButton: TButton;
    procedure GrabImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GrabImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GrabImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure GrabButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ModuleFileName: String;
    ClassName: String;
    WindowTitle: String;
    SelX, SelY, SelX1, SelY1 : Integer;
    procedure Grab(bm: TBitMap);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.Grab(bm: TBitMap);
var
  hWnd: THandle;
  pPid: DWORD;
  hProcess: THandle;
  n: Integer;
  hdcSrc: THandle;
  DestRect, SourceRect: TRect;
  pt: TPoint;
begin
  hWnd := GetForeGroundWindow;
  if hWnd = 0 then Exit;
  try
    GetWindowThreadProcessID(hWnd, pPid);
    hProcess := OpenProcess(PROCESS_ALL_ACCESS, False, pPid);
    SetLength(ModuleFileName, 255);
    n := GetModuleFileNameEx(hProcess, 0, PChar(ModuleFileName), 255);
    SetLength(ModuleFileName, n);

    SetLength(ClassName, 255);
    n := GetClassName(hWnd, PChar(ClassName), 255);
    SetLength(ClassName, n);

    SetLength(WindowTitle, 255 );
    n := SendMessage(hWnd, WM_GETTEXT, Length(WindowTitle), Integer(WindowTitle));
    SetLength(WindowTitle, n);
    
    hdcSrc := GetDC(hWnd);
    Windows.GetClientRect(hWnd, SourceRect);
    bm.Width  := SourceRect.Right - SourceRect.Left;
    bm.Height := SourceRect.Bottom - SourceRect.Top;
    DestRect := Rect(0, 0, SourceRect.Right - SourceRect.Left, SourceRect.Bottom - SourceRect.Top);
    StretchBlt(bm.Canvas.Handle, 0, 0, bm.Width, bm.Height, hdcSrc,
      0, 0, SourceRect.Right - SourceRect.Left, SourceRect.Bottom - SourceRect.Top,
      SRCCOPY);
    pt.X :=SourceRect.Left;
    pt.Y :=SourceRect.Top;
    Windows.ClientToScreen(hWnd, pt);
  finally
    ReleaseDC(0, hdcSrc);
  end;
end;

procedure TMainForm.GrabImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SelX := X;
  SelY := Y;
  SelX1 := X;
  SelY1 := Y;
  with GrabImage.Canvas do
  begin
    Pen.Width := 1;
    Pen.Style := psDashDotDot;
    Pen.Mode := pmNotXOR;
    Brush.Style := bsClear;
    Pen.Color := clBlue;
  end;
end;

procedure TMainForm.GrabImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then
  begin
    GrabImage.Canvas.Rectangle(SelX, SelY, SelX1, SelY1);
    SelX1 := X;
    SelY1 := Y;
    GrabImage.Canvas.Rectangle(SelX, SelY, SelX1, SelY1);
  end;
end;

procedure TMainForm.GrabImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  DestRect, SourceRect : TRect;
  TheFile: TextFile;
begin
  GrabImage.Canvas.Rectangle(SelX, SelY, SelX1, SelY1);
  if X <= SelX then
  begin
    SelX1 := SelX;
    SelX := X;
  end
  else
    SelX1 := X;

  if Y <= SelY then
  begin
    SelY1 := SelY;
    SelY := Y;
  end
  else
    SelY1 := Y;

  if ParamCount > 0 then
  begin
    AssignFile(TheFile, ParamStr(1));
    ReWrite(TheFile);
    Writeln(TheFile, ExtractFileName(ModuleFileName) + '|' + ClassName + '|' + WindowTitle);
    Writeln(TheFile, SelX);
    Writeln(TheFile, SelY);
    Writeln(TheFile, SelX1 - SelX);
    Writeln(TheFile, SelY1 - SelY);
    CloseFile(TheFile);
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
   SelX := 0;
   SelY := 0;
   SelX1 := 0;
   SelY1 := 0;
   MainForm.DoubleBuffered := true;
end;

procedure TMainForm.GrabButtonClick(Sender: TObject);
var
  iFlash: Integer;
begin
  MainForm.Hide;
  Sleep(5000);
  Grab(GrabImage.Picture.Bitmap);
  GrabImage.Width := GrabImage.Picture.Bitmap.Width;
  GrabImage.Height := GrabImage.Picture.Bitmap.Height;
  MainForm.SetBounds(0, 0, Screen.Width, Screen.Height);
  MainForm.FormStyle := fsStayOnTop;
  MainForm.Show;
  for iFlash := 0 to 5 do
  begin
    if odd(iFlash) then
      GrabImage.Show
    else
      GrabImage.Hide;
    Application.ProcessMessages;
    Sleep(100);
  end;
end;

end.
